
#include <stdio.h>
#include "defs.h"
#include "elmlib.h"
#include "cs_imp.h"

struct charset_type cs_ascii;
struct charset_type cs_unknown;
struct charset_type cs_onebyte;
struct charset_type cs_iso646;
struct charset_type cs_utf8;
struct charset_type cs_utf7;
struct charset_type cs_imap;

struct  map_info map_ascii;
struct  map_info map_latin1; 
struct  map_info map_koi8r; 
struct  map_info map_cp1251; 
struct  map_info map_invariant;
struct  map_info map_utf8; 
struct  map_info map_utf7; 
struct  map_info map_cp1252;
struct  map_info map_koi8u; 
struct  map_info map_885915;

struct setlist sets_iso_8859_X [10] ;
struct setlist set_latin8;
struct setlist set_utf8;

int main (argc, argv)
     int argc;
     char *argv[];
{
    char * munge;


    int i;

    if (argc != 2) {
	fprintf(stderr,"Usage: %s charset\n",argv[0]);
	exit(1);
    }

    for (i = 0; precompiled_sets[i].charset_type; i++) {
	if (precompiled_sets[i].MIME_name &&
	    0 == istrcmp(precompiled_sets[i].MIME_name,argv[1])) {
	    printf("%s\n",precompiled_sets[i].MIME_name);
	    exit(0);
	}
	if (precompiled_sets[i].codeset &&
	    0 == istrcmp(precompiled_sets[i].codeset,argv[1])) {
	    printf("codeset=\"%s\"\n",precompiled_sets[i].codeset);
	    exit(0);
	}
    }

    /* Then replace every , with : */

    munge = strdup(argv[1]);
    if (munge) {
	char * s;

	for (s = munge; *s; s++) {
	    if (',' == *s)
		*s = ':';
	}

	if (0 == strcmp(argv[1],munge))
	    exit(1);

	for (i = 0; precompiled_sets[i].charset_type; i++) {
	    if (precompiled_sets[i].MIME_name &&
		0 == istrcmp(precompiled_sets[i].MIME_name,munge)) {
		printf("%s\n",precompiled_sets[i].MIME_name);
		exit(0);
	    }
	    if (precompiled_sets[i].codeset &&
		0 == istrcmp(precompiled_sets[i].codeset,munge)) {
		printf("codeset=\"%s\"\n",precompiled_sets[i].codeset);
		exit(0);
	    }
	}
    }

    exit(1);
}


/*
 * Local Variables:
 *  mode:c
 *  c-basic-offset:4
 * End:
 */




