/* $Id: melib.h,v 1.33 2002/03/06 15:05:11 hurtta Exp $ */

/******************************************************************************
 *  The Elm (ME+) Mail System  -  $Revision: 1.33 $   $State: Exp $
 *
 *  Author: Kari Hurtta <hurtta+elm@ozone.FMI.FI>
 *****************************************************************************/

#ifdef USE_PGP

/* pgp_decode.c */

extern char pgp_passphrase[PGP_NUM][STRING];
extern int pgp_expires;

extern enum pgp_version have_pgp        P_((enum pgp_version v));
extern enum pgp_version decode_pgp_version P_((char * c));
extern int pgp_void_passphrase          P_((void));
extern int pgp_goodPassphrase           P_((enum pgp_version v));
extern int pgp_decrypt_init		P_((FILE **fpin, FILE **fpout, 
					    int opt, enum pgp_version v,
					    struct run_state *rs));
extern void pgp_decode  		P_((mime_t *,
					    in_state_t *s_in, 
					    out_state_t *s_out,
					    charset_t defcharset));

extern void pgp_SG_decoder P_((mime_t *body, mime_t *sign,
			       in_state_t   *state_in,
			       out_state_t  *state_out,
			       char *micalg, 
			       charset_t defcharset));
extern void pgp_EC_decoder P_((mime_t *init, mime_t *data,
			       in_state_t   *state_in,
			       out_state_t  *state_out,
			       charset_t     defcharset));

#endif

/* parse_util.c */

extern char * parse_dequote P_((CONST char * quoted));
typedef void decoder_hack_func P_((char *ptr, int len));
typedef decoder_hack_func *decoder_hack;
extern char * parse_decomment P_((CONST char *quoted,
				  decoder_hack decode_mime));
extern void null_decoder_hack P_((char *ptr, int len));

typedef void encoder_hack_func P_((char *buf,int size,
				    CONST char *source,int flag));
typedef encoder_hack_func *encoder_hack;
extern void null_encoder_hack P_((char *buf,int size,
				  CONST char *source,int flag));

#define   RHL_MARK_FOLDING      1
#define   RHL_CHECK_HEADER      2

extern int read_header_line             P_((FILE *,char *,int,int));
extern int state_read_hdr_line          P_((in_state_t *,char *, int, int));

typedef int header_filter    P_((header_list_ptr, int));
extern int NULL_header_filter    P_((header_list_ptr, int));

extern void state_write_headers P_((out_state_t      * s,
				    header_list_ptr    hdr,
				    header_filter    * filter,
				    int                flag,
				    int                demime,
				    charset_t          defcharset));

void state_write_header P_((out_state_t * s,
			   header_list_ptr next,
			   int                demime,
			   charset_t          defcharset));
			  
extern header_list_ptr state_read_headers P_((in_state_t *, int));
extern header_list_ptr file_read_headers  P_((FILE *, int));

extern long skip_envelope P_((struct header_rec *hdr, FILE *fp));

/* mime.c */

extern void mime_panic          P_((char *,int,char *, char *));
extern int check_encoding       P_((char *));

/* mime_decode.c */

extern int rfc822_header_filter     P_((header_list_ptr, int));
extern void rfc822_header_converter P_((header_list_ptr, int, char *, int));
extern void base64_decode	P_((in_state_t *, out_state_t *, int, int));
extern void quoted_printable_decode  P_((in_state_t *, out_state_t *,
					 int, int));
extern void null_decode		P_((mime_t *, in_state_t *, out_state_t *,
				    charset_t));
extern void mime_decode		P_((mime_t *, in_state_t *, out_state_t *,
				    charset_t));
extern void rfc1522_decode P_((char *, int));
extern void rfc1522_decode_structured   P_((int, char *, int));
extern int rfc1522_decode_encoded_atom P_((char *trg,int trg_len,
					   CONST char * src));

extern int is_rfc1522 P_((char *));

extern int set_filter	P_((mime_t *, out_state_t *, charset_t)); 
extern FILE *arrange_decoded P_((mime_t *ptr,in_state_t  *state_in,
				 out_state_t *state_out,
				 in_state_t *newstate2,
				 char **name));

extern FILE * arrange_binary P_((mime_t *ptr,
				 in_state_t  *state_in,
				 out_state_t *state_out,
				 in_state_t *newstate2,
				 char **name));


typedef void CT_decoder	        P_((mime_t *, in_state_t *, out_state_t *,
				    charset_t));
typedef CT_decoder *CT_decoder_t;
extern CT_decoder_t select_CT_decoder	P_((mime_t *));

extern int mime_notplain P_((mime_t *p));


/* mime_parse.c */

extern mime_t *mime_t_alloc             P_((void));
extern void mime_t_clear                P_((mime_t *mt));
extern void mime_t_copy                 P_((mime_t *, mime_t *));
extern void mime_t_zero                 P_((mime_t *));
extern void mime_destroy		P_((mime_t *));
extern void mime_get_disposition        P_((char *, mime_t *));
extern void mime_get_content		P_((char *, mime_t *));
extern int class_charset                P_((char *charset_value));
extern int mime_get_charset             P_((charset_t *ret, 
					    const char *buffer,
					    charset_t * display_charset,
					    charset_t default_content_charset
					    ));
extern char * mime_parse_content_opts	P_((char *));
extern void mime_warnings		P_((struct header_rec *));
extern mime_t *rfc822_parse		P_((FILE *fp, int len, 
					    charset_t defcharset));
extern mime_t * multipart_parse         P_((FILE *fp, int length, 
					    char *boundary, int opts,
					    charset_t defcharset,
					    int have_boundary));
extern int mime_get_boundary           P_((char *, char *, int));

extern int mime_parse_routine		P_((struct folder_info *folder,
					    struct header_rec *hdr,
					    FILE *fp));
extern mime_t *mime_read_header         P_((FILE *fp, int opts, 
					    charset_t defcharset));
extern mime_t *parse_mime_headers       P_((header_list_ptr headers,
					    long part_offset,
					    long body_offset,
					    int opts,
					    charset_t hdr_charset));

extern void parse_mime_headers1 P_((mime_t *ptr,
				    header_list_ptr headers,
				    long part_offset,
				    long body_offset,
				    int opts,
				    charset_t hdr_charset));

extern int is_text_type P_((char *primary_type, char *subtype,int enc));
extern int is_pre_mime_content_type P_((mime_t *ptr, char *content_type));
extern int mime_check_type P_((char *str));

/* mparser.c */

extern void mime_parser_free P_((struct mime_parser_data **P));
extern int  mime_parser_subparts P_((struct mime_parser_data *P));
extern struct mimeinfo * mime_parser_index P_((struct mime_parser_data *P,
					       int idx));

/* 0 == no parser, 1 == parser found */
extern int mime_parser_parse P_((struct mimeinfo *s,
				 charset_t defcharset,
				 FILE *fp));

extern void copy_parser_data P_((struct mime_parser_data **target,
				 struct mime_parser_data *source));				 

/* --------------- */

/* pgp_decode uses this .... */
extern void PressAnyKeyToContinue P_((void));

/* mime_decode.c uses this ... */
extern void getkey P_((int send));
extern void encode P_((char *line));


/*
 * Local Variables:
 *  mode:c
 *  c-basic-offset:4
 * End:
 */
